SystemOrganization addCategory: #'CS528-WebSetback'!

WAFileLibrary subclass: #SetbackFiles
	instanceVariableNames: ''
	classVariableNames: 'Unmatched'
	poolDictionaries: ''
	category: 'CS528-WebSetback'!

Object subclass: #SetbackWebSocketHandler
	instanceVariableNames: 'webSockets lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-WebSetback'!

!SetbackWebSocketHandler class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/7/2013 23:27'!
name: clientName port: aPort
	^ self new
	name: clientName;
	port: aPort;
	yourself.! !

!SetbackWebSocketHandler class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/7/2013 19:28'!
on: aBlock
	^ self new
	block: aBlock;
	yourself.! !

!SetbackWebSocketHandler methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/14/2013 21:09'!
distributeMessage: textMessage 
	| i |
	"Send message to all client WebSockets that we know."
	lock critical: [
		i := 1.
		webSockets do: [ :each |
			[ each sendMessage: (textMessage, ' to client: ' , i asString). i := i+1. ]
				on: NetworkError 
				do: [ :exception |
					"We can ignore this (instead of #unregister:-ing the offender), 
					since the listener process (see #value:) will do the right thing" 
					each log debug: [ exception printString, ' in ditributeMessage, ignoring' ] ] ] ]
		"(FLSerializer serializeToByteArray:  (textMessage, ' ' , i asString))"! !

!SetbackWebSocketHandler methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/8/2013 14:52'!
initialize
	webSockets := OrderedCollection new.
	lock := Mutex new.! !

!SetbackWebSocketHandler methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/8/2013 14:52'!
register: clientWebSocket
	lock critical: [
		webSockets add: clientWebSocket ]! !

!SetbackWebSocketHandler methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/8/2013 14:53'!
unregister: clientWebSocket
	lock critical: [
		webSockets remove: clientWebSocket ifAbsent: [ ] ]! !

!SetbackWebSocketHandler methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 14:00'!
value: webSocket
	[
	self register: webSocket.
	webSocket runWith: [ :message |	
		webSocket log info: [ 'Received message: ', message printString, ', echoing' ]. ] ] 
	on: ConnectionClosed 
	do: [ webSocket log debug: 'Ignoring connection close, done' ].
	
"textMessage := FLMaterializer materializeFromByteArray: (byteArrayMessage)."! !

Object subclass: #WebsocketUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-WebSetback'!

!WebsocketUtilities class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 23:03'!
RegisterServer
ZnServer startDefaultOn: 1701.
ZnServer default logToTranscript.
ZnServer default delegate map: 'ws-setback' to:(ZnWebSocketDelegate map: 'ws-setback' to: SetbackWebSocketHandler new).! !

!WebsocketUtilities class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 23:04'!
StopServer
	ZnServer stopDefault.! !

!WebsocketUtilities class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/16/2013 18:55'!
distributeMessage: aMessage
	(ZnServer default delegate prefixMap at: 'ws-setback')  handler distributeMessage: aMessage.! !

WAComponent subclass: #PlayerComponent
	instanceVariableNames: 'player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-WebSetback'!

!PlayerComponent class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 21:09'!
initialize 
	WAAdmin register: self asApplicationAt: 'player'.! !

!PlayerComponent class methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 21:20'!
player: aPlayer 
	^self new player: aPlayer.! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 21:22'!
initialize 
	super initialize.
	player ifNil: [ player := (SetbackPlayer name: 'Terry')].! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 21:07'!
player
	^player.! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 21:07'!
player: aPlayer 
	player := aPlayer.! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:33'!
renderContentOn: html 
	html table: 
		[html 
			tableRow: 
			[ 
						html tableHeading 
							class: 'playerCell';
							with: 'Score'.
						html tableHeading
							class: 'playerCell';
							with: 'Points Earned'.
						html tableHeading
							class: 'playerCell';
							with: 'Number of cards won' .].
					self renderPlayerDataOn: html.
			].
		html image url: (SetbackFiles urlOf: #stackFiveFaceDownPng)! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:40'!
renderPlayerDataOn: html

		html tableData 
			class: 'playerCell';
			with: (player gamesWon).
		html space.
		html tableData 
			class: 'playerCell';
			with: (player pointsEarned ).
		html space.
		html tableData 
			class: 'playerCell';
			with:  (player cardsWon size).
! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:42'!
style 
^'playerCell {
        border: 2px solid #dddddd;
        text-align: center;
	  height: 20px;
        width: 55px;
        font-size: 14px;
	 color: white;
        background-color: #888888;
}'! !

!PlayerComponent methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:43'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
"	anHtmlRoot stylesheet url: (SetbackFiles urlOf: #playerSetbackCss)."! !

WAComponent subclass: #WebSetback
	instanceVariableNames: 'websocket outputDiv webSocket message textMessage players player1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-WebSetback'!

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:12'!
children 
	^Array with: player1.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:12'!
initialize
	super initialize.	
	player1 := (PlayerComponent player: (SetbackPlayer name: 'Terry')).

	
"
	| rcvMessage |
	super initialize.
		webSocket ifNil: [ 
		webSocket := ZnWebSocket to: 'ws://localhost:1701/ws-setback'.
		webSocket	 sendMessage: (FLSerializer serializeToByteArray: 'Pharo Smalltalk using Zinc WebSockets & Zodiac started!!')].
		[[rcvMessage := FLMaterializer materializeFromByteArray: webSocket readMessage.
		Transcript show: rcvMessage; cr.] repeat  ] fork. ].
"! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/10/2013 15:52'!
message
	^message.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:46'!
renderContentOn: html
	html paragraph
		class: 'header'; 
		with: [
			html text: 'Welcome to CS528 - Setback project '; break.
			html text: 'Implementd by Ramesh, Terry, and Mehrdad'
		].
	html horizontalRule.
	"html table: [ self renderMainTableOn: html. ]."
	self renderMainTableOn1: html.
	html form:[
			html textInput
				id: 'txtMessage';
				callback: [ :value | textMessage := value].
			html button
				callback: [ self send ]; "onClick: 'doSend(test)';"
				text: 'Send'.
			html button
				callback: [ self connect ];
				text: 'Connect'.
			html button: 'Disconnect'.
		].
	 html div id: #output.! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:46'!
renderMainTableOn1: html 	
	html render: player1.
				html break.
	html tableData: (html render: player1).
				html space.
	html tableData:  (html render: player1)
	
! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:28'!
renderMainTableOn: html 	
	html table: 
		[html 
			tableRow: 
			[ 
				html tableData: 'empty'.
				html space.
				html tableData:  (html render: player1).
				html space.
				html tableData:  'empty'.
			];
			tableRow: 
			[ 
				html tableData: (html render: player1).
				html space.
				html tableData:'game table'.
				html space.
				html tableData:  (html render: player1)
			].
		]
	
! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/13/2013 16:56'!
send
	"webSocket sendMessage: (FLSerializer serializeToByteArray: textMessage)."! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:47'!
style
	^ '.header { text-align: center; font-size:200%; color:rgb(255,0,0); }
.highlight { color: yellow; }
.center {width:80px; height:20px; text-align:center; line-height:20px;}

body {
    color: #222;
    font-size: 75%;
    font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
}

h1 {
	text-align: center;
    color: blue;
    font-size: 2em;
    font-weight: normal;
    margin-bottom: 0.5em;
}
ul {
    list-style: none;
    padding-left: 0;
    margin-bottom: 1em;
}
li.overdue {
    color: #8a1f11;
}
li.done {
    color: #264409;
}
td {
        border: 2px solid #dddddd;
        text-align: center;
	  height: 20px;
        width: 55px;
        font-size: 14px;
	 color: white;
        background-color: #888888;

}


a {
        text-decoration: none;
        color: blue;
}

table {
        border-collapse: collapse	
}
'! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/13/2013 16:55'!
updateOutput: html
"
	| rcvMessage |
		[[rcvMessage := FLMaterializer materializeFromByteArray: webSocket readMessage.
		Transcript show: rcvMessage; cr.
		html paragraph: [html text: rcvMessage.] repeat. ] fork."! !

!WebSetback methodsFor: 'as yet unclassified' stamp: 'MehrdadBiglari 7/15/2013 22:25'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript url: (SetbackFiles urlOf: #webSocketJs).
	"anHtmlRoot stylesheet url: (SetbackFiles urlOf: #setbackCss)."
"	
	[ webSocket runWith: [ :msg |
			webSocket log info: [ 'Received message: ', msg printString ].]  ] 
		on: ConnectionClosed 
		do: [
			webSocket log debug: 'Connection close, cleaning up'.].
"		! !
PlayerComponent initialize!
